# -*- coding: utf-8 -*-
"""
Created on Thu May 31 14:22:48 2018

@author: Usuario
"""

import sys


from pyqtgraph.Qt import QtCore, QtGui

from myWidgets import anal_control_signal, digital_control_signal, activation_button, burleighWM

from pyqtgraph import dockarea
import pyqtgraph as pg


import myToolbar

import qdarkstyle
import os
os.environ['PYQTGRAPH_QT_LIB'] = 'PyQt5'
###############################################################################
#This creates the window for the gui
app = QtGui.QApplication([])
app.setStyleSheet(qdarkstyle.load_stylesheet_from_environment(is_pyqtgraph=True)) # set dark style
win = QtGui.QMainWindow()



win.setWindowTitle('My GUI')
win.setWindowIcon(QtGui.QIcon('snuffles.png'))



app_icon = QtGui.QIcon()
app_icon.addFile('snuffles.png')
app.setWindowIcon(app_icon)

area = dockarea.DockArea()
win.setCentralWidget(area)
cw = QtGui.QWidget()
win.show()
###############################################################################



# Here I create the layouts
layout397 = pg.LayoutWidget()
layout866 =  pg.LayoutWidget()
layoutPI =  pg.LayoutWidget()
layoutIMG =  pg.LayoutWidget()
layoutWM = pg.LayoutWidget()
layout397_scan = pg.LayoutWidget()
layout866_scan = pg.LayoutWidget()
layout423_scan = pg.LayoutWidget()
layout_trap_electrodes = pg.LayoutWidget()
layout_activate = pg.LayoutWidget()

# Here I create the docks
s1 = 100
s2 = 100
d397 = dockarea.Dock("Dock397", size=(s1, s2))  
d866 = dockarea.Dock("Dock866", size=(s1, s2))  
dPI = dockarea.Dock("DockPI", size=(s1, s2))   
dWM = dockarea.Dock("DockWM", size=(s1, s2))
d397_scan = dockarea.Dock("Dock 397 scan", size=(s1, s2))
d866_scan = dockarea.Dock("Dock 866 scan", size=(s1, s2))
d423_scan = dockarea.Dock("Dock 423 scan", size=(s1, s2))
dtrap_electrodes = dockarea.Dock("Dock Trap Electrodes", size=(s1, s2))
dactivate = dockarea.Dock(" ",  hideTitle=False, size = (s1/4, s2))
dactivate.hideTitleBar()

# Here I add the docks
area.addDock( dtrap_electrodes)
area.addDock(d397, 'bottom', dtrap_electrodes)
area.addDock(d866, 'bottom', d397)
area.addDock(dPI, 'bottom', d866)
area.addDock(dWM, 'bottom', dPI)
area.addDock(d397_scan, 'right', d397)
area.addDock(d423_scan, 'right', dPI)
area.addDock(d866_scan, 'right', d866)
area.addDock(dactivate, 'right', dtrap_electrodes)

area.moveDock(dWM, 'above', dtrap_electrodes)

# Here I add the layouts to the corresponding dock
d397.addWidget(layout397)
d866.addWidget(layout866)
dPI.addWidget(layoutPI)
dWM.addWidget(layoutWM)
d397_scan.addWidget(layout397_scan)
d866_scan.addWidget(layout866_scan)
d423_scan.addWidget(layout423_scan)
dtrap_electrodes.addWidget(layout_trap_electrodes)
dactivate.addWidget(layout_activate)


############ creating the controls ########################

piezoA397 = anal_control_signal('piezoA397', 13, out_minimum=0, out_maximum=4, out_step=0.01) 
piezoB397 = anal_control_signal('piezoB397', 7, out_step = 0.01)
piezoA866 = anal_control_signal('piezoA866', 14, out_minimum=0, out_maximum=4, out_step=0.01)
piezoB866 = anal_control_signal('piezoB866', 6, out_step = 0.01)
piezoA423 = anal_control_signal('piezoA423', 1, out_step = 0.01)

trapDCA = anal_control_signal('DC A', 2)
trapDCB = anal_control_signal('DC B', 3)
trapCompC = anal_control_signal('Comp C', 4)
trapCompD = anal_control_signal('Comp D', 5)



shutter397 = digital_control_signal('shutter397', 0)
shutter866 = digital_control_signal('shutter866', 2)
shutter423 = digital_control_signal('shutter423', 1)
shutterLED = digital_control_signal('shutterLED', 3)

#############Toolbar and initial loading of config ############################
myToolbar.first_load(anal_control_signal._registry)
myToolbar.incorporate_toolbar(win, anal_control_signal._registry)
###############################################################################
#here I connect the spinboxes to the daq analog outputs: 
for ao in anal_control_signal._registry:
    ao.connectSpinBoxesToDaq()


###############################################################################

#activate button
actB = activation_button()
layout_activate.addWidget(actB.button)
###############################################################################

#Adding the controls:

######### 397 ###########
layout397.addWidget(QtGui.QLabel('397'), 0, 0)
layout397.addWidget(QtGui.QLabel(piezoA397.name), 1, 0), layout397.addWidget(piezoA397.sb, 1, 1)
layout397.addWidget(QtGui.QLabel(piezoB397.name), 2, 0), layout397.addWidget(piezoB397.sb, 2, 1)
layout397.addWidget(QtGui.QLabel(shutter397.name), 3, 0), layout397.addWidget(shutter397.cb, 3, 1)

layout397_scan.addWidget(QtGui.QLabel('397 Scan piezo B'), 0, 0)
layout397_scan.addWidget(QtGui.QLabel('start'), 1, 0), layout397_scan.addWidget(piezoB397.scan_sb_start, 1, 1)
layout397_scan.addWidget(QtGui.QLabel('stop'), 2, 0), layout397_scan.addWidget(piezoB397.scan_sb_stop, 2, 1)
layout397_scan.addWidget(QtGui.QLabel('period'), 3, 0), layout397_scan.addWidget(piezoB397.scan_sb_period, 3, 1)
layout397_scan.addWidget(QtGui.QLabel('Scanning'), 4, 0), layout397_scan.addWidget(piezoB397.scan_button, 4, 1)
layout397_scan.addWidget(piezoB397.scanLabelValue, 5, 0)
layout397_scan.addWidget(piezoB397.scanpBar, 5, 1)

#########################

######### 866 ###########
layout866.addWidget(QtGui.QLabel('866'), 0, 0)
layout866.addWidget(QtGui.QLabel(piezoA866.name), 1, 0), layout866.addWidget(piezoA866.sb, 1, 1)
layout866.addWidget(QtGui.QLabel(piezoB866.name), 2, 0), layout866.addWidget(piezoB866.sb, 2, 1)
layout866.addWidget(QtGui.QLabel(shutter866.name), 3, 0), layout866.addWidget(shutter866.cb, 3, 1)

layout866_scan.addWidget(QtGui.QLabel('866 Scan piezo B'), 0, 0)
layout866_scan.addWidget(QtGui.QLabel('start'), 1, 0), layout866_scan.addWidget(piezoB866.scan_sb_start, 1, 1)
layout866_scan.addWidget(QtGui.QLabel('stop'), 2, 0), layout866_scan.addWidget(piezoB866.scan_sb_stop, 2, 1)
layout866_scan.addWidget(QtGui.QLabel('period'), 3, 0), layout866_scan.addWidget(piezoB866.scan_sb_period, 3, 1)
layout866_scan.addWidget(QtGui.QLabel('Scanning'), 4, 0), layout866_scan.addWidget(piezoB866.scan_button, 4, 1)
layout866_scan.addWidget(piezoB866.scanLabelValue, 5, 0)
layout866_scan.addWidget(piezoB866.scanpBar, 5, 1)
#########################

######### PI ###########
layoutPI.addWidget(QtGui.QLabel('Photoion'), 0, 0)
layoutPI.addWidget(QtGui.QLabel(piezoA423.name), 1, 0), layoutPI.addWidget(piezoA423.sb, 1, 1)
layoutPI.addWidget(QtGui.QLabel(shutter423.name), 2, 0), layoutPI.addWidget(shutter423.cb, 2, 1)
layoutPI.addWidget(QtGui.QLabel(shutterLED.name), 3, 0), layoutPI.addWidget(shutterLED.cb, 3, 1)

layout423_scan.addWidget(QtGui.QLabel('423 Scan piezo A'), 0, 0)
layout423_scan.addWidget(QtGui.QLabel('start'), 1, 0), layout423_scan.addWidget(piezoA423.scan_sb_start, 1, 1)
layout423_scan.addWidget(QtGui.QLabel('stop'), 2, 0), layout423_scan.addWidget(piezoA423.scan_sb_stop, 2, 1)
layout423_scan.addWidget(QtGui.QLabel('period'), 3, 0), layout423_scan.addWidget(piezoA423.scan_sb_period, 3, 1)
layout423_scan.addWidget(QtGui.QLabel('Scanning'), 4, 0), layout423_scan.addWidget(piezoA423.scan_button, 4, 1)
layout423_scan.addWidget(piezoA423.scanLabelValue, 5, 0)
layout423_scan.addWidget(piezoA423.scanpBar, 5, 1)

#########################

######### trap electrodes ###########
layout_trap_electrodes.addWidget(QtGui.QLabel('Trap electrodes'), 0, 0)
layout_trap_electrodes.addWidget(QtGui.QLabel(trapDCA.name), 1, 1), layout_trap_electrodes.addWidget(trapDCA.sb, 1, 2)
layout_trap_electrodes.addWidget(QtGui.QLabel(trapDCB.name), 2, 1), layout_trap_electrodes.addWidget(trapDCB.sb, 2, 2)
layout_trap_electrodes.addWidget(QtGui.QLabel(trapCompC.name), 1, 3), layout_trap_electrodes.addWidget(trapCompC.sb, 1, 4)
layout_trap_electrodes.addWidget(QtGui.QLabel(trapCompD.name), 2, 3), layout_trap_electrodes.addWidget(trapCompD.sb, 2, 4)


###########################################################

#all shutter start in False: 
shutters = [shutter397, shutter866, shutter423, shutterLED]
try:
    for sh in shutters:
        sh.DO.set_out(True)
except:
    pass    

###############################################################################
#read wavemeter

wavemeter = burleighWM(layoutWM, dWM)


###############################################################################


if (sys.flags.interactive != 1) or not hasattr(QtCore, 'PYQT_VERSION'):
    QtGui.QApplication.instance().exec_()
