# -*- coding: utf-8 -*-
"""
Created on Thu Jul  5 12:17:30 2018

@author: Usuario
"""


from PyQt5.QtCore import QSettings
from PyQt5.QtWidgets import QAction, QFileDialog
from threading import Thread
#%%

def save(aos):
    settings = QSettings('C:\\Users\\Usuario\\Documents\\control_app\\config.ini', QSettings.IniFormat)
    settings.beginGroup('Ventana')
    for ao in aos:
        spin_boxes = ao.spin_boxes
        
        for text, spinb in spin_boxes:
            settings.setValue(str(ao.name) + '_' + text, spinb.value())
            #print(spinb.value() )
    settings.endGroup()
    print('saving')
    
def load(aos):
    settings = QSettings('C:\\Users\\Usuario\\Documents\\control_app\\config.ini', QSettings.IniFormat)
    settings.beginGroup('Ventana')
    for ao in aos:
        spin_boxes = ao.spin_boxes
        for text, spinb in spin_boxes:
            spin = settings.value(str(ao.name) + '_' + text)
            spinb.setValue( float(spin) )
    settings.endGroup()

def first_load(aos):
    try:
        settings = QSettings('C:\\Users\\Usuario\\Documents\\control_app\\config.ini', QSettings.IniFormat)
    except:
        print('Warning: no config.ini file in control_app folder. Pleace, be kindful and create one')
        return 
    
    settings.beginGroup('Ventana')
    for ao in aos:
        spin_boxes = ao.spin_boxes
        for text, spinb in spin_boxes:
            spin = settings.value(str(ao.name) + '_' + text)
            spinb.setValue( float(spin) )
    settings.endGroup()
    
    
def save_as(aos, window):
    name = QFileDialog.getSaveFileName(window, 'Save File')
    
    file = open(name[0], 'w+')
    file.close()
    settings = QSettings(name[0], QSettings.IniFormat)
    settings.beginGroup('Ventana')
    for ao in aos:
        spin_boxes = ao.spin_boxes
        
        for text, spinb in spin_boxes:
            settings.setValue(str(ao.name) + '_' + text, spinb.value())
            #print(spinb.value() )
    settings.endGroup()
    print('saving to %s' % name[0])
    
def open_from(aos, window):
    name = QFileDialog.getOpenFileName(window, 'Save File')
    
    settings = QSettings(name[0], QSettings.IniFormat)
    settings.beginGroup('Ventana')
    for ao in aos:
        spin_boxes = ao.spin_boxes
        for text, spinb in spin_boxes:
            spin = settings.value(str(ao.name) + '_' + text)
            spinb.setValue( float(spin) )
    settings.endGroup()
    
def startWebcamsThread():
    exec(open('C:\\Users\\Usuario\\Documents\\control_app\\webcams.py').read())
    
def putWebcams(checked):
    if checked:
        t = Thread(target=startWebcamsThread, args=())
        t.start()
    else:
        pass
        
def incorporate_toolbar(win, analog_control_signals):

    menubar = win.menuBar()

    
    
    saveAct = QAction('Save', win)        
    loadAct = QAction('Load', win)
    saveAsAct = QAction('Save as' , win)
    openFromAct = QAction('open from', win)
    
    win.statusBar()
    menubar = win.menuBar()
    fileMenu = menubar.addMenu('&File')
    
    fileMenu.addAction(saveAct)
    fileMenu.addAction(loadAct)
    fileMenu.addAction(saveAsAct)
    fileMenu.addAction(openFromAct)
    
    
    viewMenu = menubar.addMenu('Monitor')
    viewWebcams = QAction('View webcams', win, checkable=True)
    viewWebcams.setChecked(False)
    viewMenu.addAction(viewWebcams)
    
    
    saveAct.triggered.connect(lambda: save(analog_control_signals))
    loadAct.triggered.connect(lambda: load(analog_control_signals))
    saveAsAct.triggered.connect(lambda: save_as(analog_control_signals, win))
    openFromAct.triggered.connect(lambda: open_from(analog_control_signals, win))
    viewWebcams.toggled.connect(lambda: putWebcams(viewWebcams.isChecked()) )